FastCopy Help

FastCopy ver2.08

2011/02/28 H.Shirouzu (白水啓章)

Index

1. 概要
2. ライセンス＆免責
3. 動作環境
4. インストール・アンインストール
5. 使用法＆画面説明
6. コマンドラインモード
7. 注意（危険なところ）
8. 最新版＆連絡先
9. その他
10. ToDo
11. 履歴

1. 概要

Windows系最速(?) のファイルコピー＆削除ツールです。

NT系OS の場合、UNICODE でしか表現できないファイル名や MAX_PATH(260文字) を越えた位置のファイルもコピー（＆削除）できます。

自動的に、コピー元とコピー先が、同一の物理HDD or 別HDD かを判定 した後、以下の動作を行います。
別HDD間 | マルチスレッドで、読み込みと書き込みを並列に行う
同一HDD間 | コピー元から（バッファが一杯になるまで）連続 読み込み後、コピー先に連続して書き込む

Read/Write も、OS のキャッシュを全く使わないため、他のプロセス （アプリケーション）が重くなりにくくなっています。

可能な限り大きな単位で Read/Write するため、デバイスの限界 に近いパフォーマンスが出ます。

Include/Exclude フィルタ（UNIXワイルドカード形式）が指定可能です。

MFC 等のフレームワークを使わず、Win32API だけで作っています ので、軽量＆コンパクト＆軽快に動作します。

全ソースコードは BSD ライセンスで公開していますので、VC++ 等 をお持ちであれば、ご自由にカスタマイズしての利用も可能です。

2. ライセンス＆免責

Copyright 2004-2011 SHIROUZU Hiroaki All rights reserved.

ソースコード形式であれバイナリ形式であれ、変更の有無に関わらず、以下の条件を満たす限りにおいて、再配布および使用を許可します:
1. ソースコード形式で再配布する場合、上記著作権表示、本条件書、および下記免責表示を必ず含めてください。

2. バイナリ形式で再配布する場合、上記著作権表示、本条件書、および下記免責表示を、配布物とともに提供される文書及び他の資料に必ず含めてください。
SHIROUZU Hiroaki および貢献者は、本ソフトウェアの使用/利用によるいかなる損失に対しても、責任を負いません。

3. 動作環境

Windows 98/Me/NT/2000/XP/2003/Vista/2008/Win7
（MFCXX.dll は必要ありません）

4. インストール・アンインストール

インストール

setup.exe を実行して、任意のディレクトリにインストールしてください。
（インストールディレクトリへのコピーと、ショートカットの作成を行います）
USB メモリ等に格納して使用する場合は、fastcopy.exe, fastcopy.chm のみをコピーしてお使いください。（この場合、シェル拡張は使えません）

アンインストール

インストールディレクトリの setup.exe を使ってアンインストールすることができます。
（ショートカットの削除とシェル拡張の解除を行います）
なお、シェル拡張を行っていた場合、完全な削除は OS再起動後になります。

5. 使用法＆画面説明

ウィンドウの最小化で、タスクトレイに格納します。
（さらに、コピー動作中は、アイコンが回転します）
画面説明は、以下の通りです。

Source / DestDir

Source(コピー元) と DestDir(コピー先ディレクトリ) を指定します。
（デフォルトでは、過去10世代分記憶します）
Source を複数指定（ドラッグ＆ドロップ可）する場合は、セミコロンで区切ります。
（なお、セミコロンを含むパス名は、""で括って指定します）

Source へのドラッグ＆ドロップ時に CTLキーを押している場合、現在の Source 内容に追加する形になります。（押していない場合は、現在の Source 内容はクリアされます）
また、DestDir 入力欄への（ディレクトリの）ドロップも可能です。

DestDir 指定の末尾に '\' があるかどうかによる挙動の違い

Source 指定が１ディレクトリのみで、DestDir 指定の末尾に '\' がない場合
Source ディレクトリ自体はコピーせず、Source ディレクトリ配下の内容を DestDir 配下にコピーします。
（DestDir\SourceDirの中身）

それ以外の場合
Source ディレクトリ自体を含めて、DestDir 配下にコピーします。
（DestDir\SourceDir\SourceDirの中身）

動作モード

モード | 動作内容
差分（上書きなし） | 同じファイル名がある場合、コピーしません。
差分（サイズ・日付） | 同じファイル名がある場合、サイズもしくは日付が違う場合のみ、コピーします。（デフォルト）
差分（最新日付） | 同じファイル名がある場合、日付が新しい場合のみ、コピーします。
コピー（全上書き） | 常に上書きコピーします。
同期（サイズ・日付） | 同じファイル名がある場合、サイズもしくは日付が違う場合のみ、コピーします。 さらにコピー元に存在しない、コピー先ファイル（＆ディレクトリ）をすべて強制削除します。
移動（全上書き） | 上書きコピーした上で、コピー元を全削除します。（一般設定にて、移動（サイズ・日付）に変更することができます）
全削除 | 指定されたファイル（＆ディレクトリ）を全て強制削除（＝読み取り専用属性がついたファイルも属性をクリアした後、削除）します。

ボタン＆オプション指定

実行 | コピー動作を実行します。実行中は、中断...ボタンに変化します。 （なお、CTLキーを押しながら実行を押すと、ソース一覧が表示された確認ダイアログが出てきます）
リストアップ | コピー＆削除される（予定の）ファイルを、リストアップして表示します。頭に '+' は作成・更新され、'-' は削除されます。 （なお、CTLキーを押しながらリストアップを押す（ボタン名「リストアップ」→「リストアップ+V」）と、スキップ対象（ただしフィルタ除外は除く）のファイルペアについて、読み込み＆ハッシュ値比較を行います）
Buffer 指定 | Read/Write に使う、バッファサイズを MB 単位で指定します。
速度コントロール | 最大(Full Speed)、自動速度制限(Auto Slow)(*1)、速度指定(90%～10%)、停止(Suspend) を指定することができます。重いと感じる場合は「自動速度制限」を試すと良いでしょう（マウスや最前面ウィンドウの変化を検知すると、一定時間、遅くします）。また「最大」以外の場合は、プロセス優先度クラスを「低」に落とします。（ジョブ管理での保存項目対象にはなりません）
エラー時継続 | Read/Write/Delete等で、エラーが発生しても、中断せず、可能な限り動作を続けます。 （ただし、エラー表示欄やエラーログには残ります）
ベリファイ | MD5(or SHA-1) による書き込みデータのベリファイを行います。（SHA-1 を利用する場合は、fastcopy.ini の [main] に using_MD5=0 を設定します） なお、具体的には、次のような比較を行います。 Read(Src) -> MD5(Src) -> Write(Dst) -> Read(Dst) -> MD5(Dst) -> MD5比較(Src/Dst) （各ステージが、複数のファイルを跨ったパイプラインのように並列して処理されます）
完了時間予測 | コピー開始前に、コピー元の総ファイル数・総ファイルサイズを調べることで、完了時間を予測します。 （なお、削除モードでの予測はできません。また、移動モードの場合、削除時間は予測に含んでいません）
Top | 常に最前面に表示します。
直ちに開始 | 他の FastCopy が実行中の場合に、その完了を待つことなく、直ちに実行を開始します。（なお、他の FastCopy がコピー・移動中でない場合、このボタンは現れません）
「?」 | ヘルプを表示します。
（*1)FastCopy がアクティブでない状態でマウス移動を検出すると速度制限します。具体的には、I/O 動作の合間にウェイトを入れる、プロセス優先度を下げる、I/O優先度を下げる(Vistaのみ)、最大I/Oサイズを1MBに低下させる、等により動作速度を制限します。なお、動作内容は、将来、変更される可能性があります

ACL属性 | NTFS のアクセスコントロールリスト(ACL)をコピーします
副次Stream | NTFS の副次ストリーム(Alternate Stream)をコピーします
復元無効化（上書き後に削除） | 削除する前に、対象ファイルをリネームした後、ランダムデータで上書きすることで、削除ファイルの復元を実質的に無効化します。なお、副次ストリームの上書きは行いません。設定で「NSA 方式」を選択していた場合は、２回ランダムなデータで上書きした後、最後に 0 で上書きします。（なお、復元できないという保証はありませんのでご注意）

Filter | 各種フィルタの有効／無効を指定します。なお、移動モードでは、フィルタ指定は無視されます。
Include | 指定文字列（UNIXワイルドカード形式可）にマッチするファイルのみをコピー対象にします。複数指定する場合は、セミコロンで区切ります。ディレクトリを指定する場合は、文字列の末尾に '\' を付与します。（例： *.txt; My Folder[0-9]\） ファイルまたはディレクトリに対して、それぞれ明示的な指定がない場合は、* もしくは *\ を指定したものと見なします。 なお、削除モード＋ファイルに対する Include指定をした場合、ディレクトリは削除されません。
Exclude | Include の反対で、マッチするファイル・ディレクトリを除外します。
以下のフィルタは、設定→拡張フィルタ表示を有効にした場合のみ表示されます
FromDate | 指定日時（書式）以降の更新タイムスタンプを持つファイルを対象とします。 書式は絶対日付指定("20090101")以外に、相対日付も可能です(10日前: '-10D')
ToDate | 指定日時以前の更新タイムスタンプを持つファイルを対象とします。
MinSize | 指定サイズ以上のファイルを対象とします。末尾に K/M/G/T を付与することで、サイズの略記表記可能です。
MaxSize | 指定サイズ以下のファイルを対象とします。

 Include / Exclude フィルタ指定で使用可能なワイルドカード書式
* | 0文字以上の任意の文字
? | 1文字の任意の文字
[abc] | abc のどれか 1文字
[!abc] | abc のどれか 1文字以外。'!' の代わりに '^' でも可
[a-z] | a-z までの任意の1文字
\ | エスケープ文字（なお、末尾の \ だけはディレクトリを表します）
（注意：将来的に、フィルタ指定形式は大幅に変更されるかもしれません）

FromDate/ToDate フィルタ指定の書式
絶対日時指定 | 日時を YYYYMMDD で指定
相対日時指定 | -10D（10日前）などのように、"+|- 数字 W|D|h|m|s" の書式で指定します。 W|D|h|m|s はそれぞれ、週、日、時、分、秒を表します。 （大文字小文字を区別します）

ジャンクション・シンボリックリンク

v1.70から、ジャンクション（含むマウントポイント）・シンボリックリンクを認識するようになりました。
モード | 動作内容
差分・コピー | デフォルトでは、ジャンクション・シンボリックリンク自体をコピーします。設定＆コマンドラインにより、指し示す先の配下をコピーする形にもできます。
移動 | 常に、ジャンクション・シンボリックリンク自体を移動します。
削除 | 常に、ジャンクション・シンボリックリンク自体を削除します。

ハードリンク

v1.95から、/linkdest を指定して起動したときのみ、ハードリンクを再現することが可能になりました。
（実行時の TotalFiles: 表示が、"ファイル数（ディレクトリ数）" から "ファイル数/ハードリンク数（ディレクトリ数）" に変化します）

注意点は以下の２つです。
１．ハードリンク実体1万ファイルあたり、2-4MB程度メモリを消費します（パス長に依存）。
２．差分コピー動作が遅くなります。（リンクカウンタ取得用にスキップ対象のファイルもオープンするため）。

/linkdest 指定した場合、/recreate オプション相当の動作が常に有効になります。
常時、ハードリンク再現を有効にしたい場合、fastcopy.ini [main] linkdest=1 にします。
また、linkdest=2 とすると、スキップ対象ファイルもハードリンク検査対象に含めます。

ジョブ管理 → ジョブ追加・削除

メインウィンドウの記述内容を、ジョブという単位で、保存＆呼び出しできるようにします。
追加・更新 | メインウィンドウ内容（Source/DestDir, コマンドモード, フィルタ指定、バッファ指定、エラー時継続オプション、完了時間予測、自動/同一/別HDDモード）にジョブ名を付けて保存・更新します。
削除 | 選択したジョブを削除します。

設定 → 一般設定

FastCopy の一般設定（各種デフォルト値、I/Oパラメータ、ログ記録等）を行います。

設定 → シェル拡張設定

Explorer の右クリックメニューに、FastCopy のコピー・削除メニューを登録/解除します。

設定 → 自動/同一/別HDDモード

自動/同一/別HDDモードを指定します（デフォルトは自動）。なお、CTL+K で各モードに、順次、切り替えすることもできます。

設定 → Source ⇔ DestDir の交換

相互に同期したい場合などのために、Source と DestDir の内容を交換します。その際、末尾の '\' の有無による挙動の違いなどを踏まえて、パス内容を必要に応じて加工します。（例えば、Source: C:\AAA\BBB、DestDir: D:\CCC\ の場合、Source: D:\CCC\BBB、DestDir: C:\AAA\ となります）
なお、Source が複数指定されている場合は、利用できません。
CTL+ALT+S でも実行可能です。

設定 → 終了時処理

終了時処理を選択します。標準、スタンバイ、休止、シャットダウンがデフォルトで用意されています。
さらにサウンド設定やコマンド実行などを追加することができます。新しい終了時処理を追加することも可能です。

6. コマンドラインモード

基本的な書式は、以下の通りです。

  fastcopy.exe [/オプション類] file1 file2 ... [/to=dest_dir]
  （なお、GUI モードと違い、区切り文字は空白文字になります。従い、空白文字を含むパス名は、"" で括って指定してください。）

指定可能なオプションは、以下の通りです。 （なお、'=' の前後には空白を入れないで下さい）

/cmd=(noexist_only|diff|update|sync|force_copy|move|delete) ... 動作モード指定。
  （cmd 指定省略時は diff モード。delete 指定時は、/to=dest_dir は使いません）
cmdline | GUIでの表記
noexist_only | 差分（上書きなし）
diff | 差分（サイズ・日付）
update | 差分（最新日付）
force_copy | コピー（全上書き）
sync | 同期（サイズ・日付）
move | 移動（全上書き）
delete | 全削除
/auto_close ... コピー終了後、自動的に終了します

/force_close ... コピー終了後、エラーが発生していた場合も、強制的に終了します

/open_window ... タスクトレイに格納しません（直ちに実行開始しない場合は指定不要）

/estimate ... コピー完了時間予測を行います

/no_exec ... パラメータをメインウィンドウにセットしますが、実行はしません

/no_confirm_del ... /delete 時に、動作開始の問い合わせをしません

/no_confirm_stop ... 継続不能エラー発生時にも、エラーを出しません

/error_stop ... エラー発生時にダイアログを出し、続行するかを問い合わせます（/error_stop=FALSE で抑止）

/bufsize=N(MB) ... バッファサイズを MB 単位で指定します

/log ... ログファイル(fastcopy.log) にログを出力します（/log=FALSE で抑止）

/logfile=ログファイル名 ... ログファイル名を指定します

/filelog ... 詳細ファイルログを記録します。FastCopy/Log フォルダ配下に、日付.log という形式で保存されます。ベリファイ時はハッシュ値（通常 MD5、設定によって SHA1）も記録されます。（/filelog=filename で指定ファイルに保存可能。ただし、同じファイルを指定して、同時に複数の FastCopy を実行した場合、ログ出力が交互に混じる可能性があります）

/utf8 ... UTF-8でログを記録します

/skip_empty_dir ... フィルタ指定時、空ディレクトリをコピーしません（/skip_empty_dir=FALSE で抑止）

/job=ジョブ名 ... 事前に登録してあるジョブを指定します

/force_start ... 他の FastCopy がコピー実行中の場合も直ちに実行します（/force_start=FALSE で抑止）

/disk_mode=(auto|same|diff) ... 自動/同一/別HDDモードを指定します。（デフォルト: auto）

/speed=(full|autoslow|9-1(90%-10%)|suspend) ... 速度コントロールを行います。

/srcfile="files.txt" ... Source内容をファイルで指定します。１行に１ファイルを記述します。（なお、大量のファイルを指定すると、Sourceコンボボックスの表示/再描画に非常に時間が掛かります）

/srcfile_w="files.txt" ... /srcfile= と同様ですが、UNICODE で記述します。

/include="..." ... Include フィルタを指定します（詳細）

/exclude="..." ... Exclude フィルタを指定します（詳細）

/from_date="..." ... 更新日付フィルタ（最古）を指定します（詳細）

/to_date="..." ... 更新日付フィルタ（最新）を指定します（詳細）

/min_size="..." ... サイズフィルタ（最小）を指定します（詳細）

/max_size="..." ... サイズフィルタ（最大）を指定します（詳細）

/wipe_del ... 削除モード時に、ファイルを削除する前に上書き＆リネームして、復元を無効にします（/wipe_del=FALSE で抑止）

/acl ... アクセスコントロールリスト(ACL)をコピーします（NTFSのみ有効）（/acl=FALSE で抑止）

/stream ... 副次ストリームをコピーします（NTFSのみ有効）（/stream=FALSE で抑止）

/reparse ... ジャンクション・マウントポイント・シンボリックリンクを（配下ではなく）それ自体をコピーします（/reparse=FALSE で配下をコピー）（詳細）

/verify ... MD5(or SHA-1) による書き込みデータのベリファイを行います（/verify=FALSE で抑止）

/linkdest ... ハードリンクを可能な限り再現します。詳細は こちらを参照 ください。

/recreate ... ファイル更新の挙動を、既存ファイルの上書きから、既存ファイル削除＆再生成に変更します。（/linkdest 指定時には、/recreate指定の有無に関わらず、この動作を行います）常時、この動作を有効にしたい場合、fastcopy.ini [main] recreate=1 にします。

/postproc=終了時処理名 ... 事前に登録してある終了時処理名を指定します。（/postproc=FALSE で抑止）

例） C:\test 配下を D:\Backup Folder に差分コピーする場合
  fastcopy.exe /cmd=diff C:\test /to="D:\Backup Folder\"

7. 注意（危険なところ）

コピー先ファイルは、動作モードに応じて、問い合わせなしに、強制的に上書きすることがあります。
同期モードでは、状況に応じて、コピー先のファイル＆ディレクトリを強制削除します。
削除モードでは、ファイル＆ディレクトリを常に強制削除します。
（強制削除＝読み取り専用属性がついている場合、それをクリアしてから削除）

万一バグがあれば、悲惨な結果になる可能性があります。
（「2. ライセンス＆免責」を熟読のこと）

8. 最新版＆連絡先

以下の URL に最新版＆掲示板があります。
 http://ipmsg.org/tools/fastcopy.html
http://ipmsg.org/private/

9. その他

  • 設定ファイル(FastCopy.ini)およびログファイルは、
    Vista以降かつ \Program Files 配下にインストールした場合、\Users\(USER)\AppData\roaming\FastCopy\ 配下に（メニューのファイル(F) → UserDir(U)）保存します。
    それ以外の場合、FastCopy.exe の存在するフォルダに保存されます。
  • 他のアプリケーション等への組み込みについて
    高速コピーのコア部分(fastcopy.cpp/h)は、GUI 部分から独立させて作ってあります。
    BSDライセンスに基づいて、ご自由にお使いください。
  • 万一、異常終了（例外）した場合、fastcopy_exception.log が生成されます。 （作者に送ると、品質向上のための手がかりになります）

    • 10. ToDo

  • ネットワーク対応（２つのPCに入れた fastcopy 同士で高速転送）
  • 簡易比較の高速化

    • 11. 履歴

    Version | 説明
v2.08 | Sourceフォルダ選択で、CTLキーを押しながらのOK押下でパス名追加動作に。パス履歴が保存されない問題の修正(v2.07のみ)。
v2.07 | メインウィンドウリサイズ時のコンボボックスの自動補完/選択を抑止。その他リファイン
v2.06 | ベリファイ時にエラーとなることがあったのを修正(v2.05のみ)。
v2.05 | Win98で設定が保存できない問題を修正。ACL/副次Streamエラーの記録を選択可能に。
v2.04 | 特権昇格後にもドラッグ＆ドロップできるように。FastCopyシェル拡張DLLを日本語フォルダ内においた場合にシェル拡張が利用できなかった問題を修正。設定ダイアログ＆その他リファイン
v2.03 | 英語UI時に「特権」メニュー項目が効かない問題を修正。その他リファイン
v2.02 | x64 ネイティブ版をリリース。Vista以降で \Program Files 配下にインストールした場合、UAC環境でなくても fastcopy.ini やログファイルを \Users\(USER)\AppData\roaming\FastCopy 配下に保存するように変更。セミコロンを含むファイル名を指定するとエラーが出る場合があったのを修正。その他、修正＆リファイン。
v2.01 | 同一HDD内での大量移動が完了しないことがあったのを修正。Source/DestDir指定に絶対パスを必要としない形に戻した。
v2.00 | 簡易比較機能の追加（CTLキーを押しながら「リストアップ」）。UAC有効な環境で \Program Files 配下にインストールした場合、fastcopy.ini やログファイルを \Users\(USER)\AppData\roaming\FastCopy 配下に保存するように変更。物理HDDグループを手動設定を可能に。DestDir指定の中間フォルダが存在しない場合は作成するように。64bitOSでの32bitシェル拡張に対応。ジョブ管理削除時の例外発生を修正。
v1.99r4 | コピー先に、大文字小文字の違うファイル名が存在する場合に、コピー元に合わせるように変更（全上書き以外）。詳細エラーが表示されないことがあったのを修正
v1.99r3 | 同一HDD内の別パーティション間コピーが、別HDDモードに誤判定される問題の修正(v.199r2のみ)。時間予測の精度を少し向上。
v1.99r2 | 詳細ファイルログ機能(/filelog)を追加（ベリファイ時はハッシュ値(Default:MD5)も出力）。移動モードでのフィルター機能を利用可能に。起動を高速化（iniファイルを独自ライブラリ経由のアクセスに変更）。Sourceで直接指定したファイルに対しても、フィルタが効くように変更。/srcfile で MBCS文字を使えなかった問題を修正。その他リファイン。
v1.98 | 拡張（サイズ＆更新日付）フィルタを追加（設定→拡張フィルタ表示）
v1.97 | 終了時処理設定時のサウンド再生が行われないことがあったのを修正。その他リファイン
v1.96 | ハードリンク再現オプション指定時(/linkdest)、ファイル更新の動作を、既存ファイルを上書き→削除＆再作成に変更した。また、ハードリンク再現オプション指定に関わらず、ファイル更新動作を削除＆再作成にするオプション(/recreate)を追加
v1.95 | ハードリンクを再現するオプション(/linkdest)の追加。終了時処理通知ダイアログが最前面表示されるように変更。コピー終了時に不正なメモリ開放をすることがあったのを修正(v1.93-v1.94)。ACL/Streamのコピーに失敗することがあったのを修正。
v1.94 | ヘルプファイルが開かなかったのを修正(v1.93のみ)
v1.93 | 終了時処理設定（Shutdown、コマンド実行等を可能に）を追加。「ログを開く」メニューを追加。ファイルによるSource指定オプション（/srcfile=）を追加。ジョブ管理で「削除モード」を「移動モード」として保存していたのを修正（v1.80-v1.92）。インストーラのショートカット作成オプションが効いていなかったのを修正（v1.92のみ）
v1.92 | シェル拡張に「タスクトレイで実行」オプションを追加。エラー発生時に、コピー先に不完全なファイルが残ることがあったのを修正。英語モードの表記を少し改善
v1.91 | 英語UIモードの追加。復元無効化付き削除に失敗することがあったのを修正。ベリファイ付き移動時に、稀に処理が進まなくなる可能性があったのを修正。ディレクトリ選択ダイアログでネットワークドライブが見えなくなっていたのを修正。
v1.90 | ベリファイ動作の高速化（I/O とハッシュ計算を別スレッド化して並列処理）。ベリファイ用ハッシュアルゴリズムに MD5 を追加し、MD5をデフォルトに変更（fastcopy.ini で [main] using_MD5 = 0 とすれば SHA-1 を利用）。ウィンドウの位置＆サイズ固定機能、および、Source ⇔ DestDir 交換機能を追加。
v1.84 | フィルタ文字列登録で、（種類ごとの）登録文字数合計が62*n文字（メタ文字を除く）の境界で終わる文字列が登録されなかったのを修正。
v1.83 | 読み込み側OSキャッシュ利用ONの場合も、ベリファイ用読み込み時は無効化するようにした
v1.82 | 読み込み側OSキャッシュを利用するオプション追加（OSキャッシュに載っているファイルは高速読み込みされるが、そうでない場合、無駄にOSキャッシュを利用して他の仮想メモリをスワップアウトさせる原因になるので、標準では非推奨）
v1.81 | ベリファイ付き移動でベリファイエラーが発生すると終了しない場合があったのを修正
v1.80 | 書き込みデータのベリファイ(SHA-1)オプションを追加。シェル拡張での「貼り付け」をサポート。移動（全上書き）を（サイズ・日付）に変更するオプションの追加。逐次移動オプションの追加。移動モード時に一部でエラーが発生した場合にも、正常にコピーできたファイルについては削除を継続する動作に変更。最大IOサイズ設定が大きすぎる場合（=ERROR_NO_SYSTEM_RESOURCES発生時）に、自動的にIOサイズを落として継続可能にした。終了予測を若干改善。継続不能時も確認ダイアログを出さないオプション(/no_confirm_stop)を追加。プロセスの戻り値について、エラー発生時には -1 を返すようにした
v1.71 | Win2000/Me/98 でシェル拡張登録時に異常終了することがあったのを修正
v1.70 | ジャンクション＆シンボリックリンクに対応（デフォルトでは配下ではなく、リンク自体をコピー。削除では常にリンクだけを削除）。Vista UAC（特権昇格）対応。64bit版シェル拡張DLL同梱。エラーログのUTF-8出力オプション追加。復元無効化削除でもハードリンクされているファイル場合は上書きなしの削除に。ログファイル名指定オプション(/logfile=)追加。エラーログ領域が小さくなっていたのを修正。その他リファイン。
v1.63 | include/excludeフィルタの上限文字数を62->2048文字に変更。その他、リファイン
v1.62 | v1.60,v1.61で、コピー先ファイル作成エラーが発生する場合があったのを修正
v1.61 | v1.60で、src フィールドの入力が8192文字を超えていた場合に、実行時に 8192文字に切り詰められてしまう問題を修正
v1.60 | NTFS アクセスコントロールリスト(ACL)、副次ストリームのサポート。削除時の復元無効化オプション（単純上書き＆NSA方式）追加。自動速度制限をスライダコントロールに変更（フルスピードから完全停止まで、12段階のコントロール）。自動速度制限時にプロセス優先度クラスを調整。
v1.55 | タスクトレイ実行時の問い合わせダイアログが左上に出ていたのを修正(v1.53以降)
v1.54 | NT4.0で動作するように修正
v1.53 | コマンドラインでタスクトレイ実行する場合は、フォーカスを奪わないように修正。マルチモニタ使用時に、マウスの存在するモニタ側にウィンドウを出すように変更。/error_stopが効いていなかったのを修正(v1.52のみ)。
v1.52 | 自動速度制限機能の追加。一部の UDFファイルシステムで、同一タイムスタンプ判定が必要以上に厳しくなっていたのを修正。コマンドラインオプションの抑止指定（=FALSE）が有効に働いていなかったのを修正
v1.51 | 完了時間予測機能利用時に、異なる複数のディレクトリをsrcに指定すると落ちることがあったのを修正
v1.50 | 同期モードでのフィルタ指定を可能に。その他、リファイン
v1.40 | ジョブ管理機能の追加。処理内容の事前リストアップ機能の追加。多重実行制御オプションの追加。フィルタ指定時に、空ディレクトリを作成しないオプションを追加。自動/同一/別HDDモード指定の追加。メインウィンドウのリサイズを可能に。APIエラーの説明表示。その他、リファイン
v1.32 | コマンドライン時に Include/Excludeフィルタが無効になっていたのを修正。その他、リファイン
v1.31 | Include/Excludeフィルタで、多数の指定をした場合に、実行直後に落ちることがあったのを修正
v1.30 | Include/Excludeフィルタ機能追加。同一ディレクトリ内でドラッグ＆ドロップした場合、複製を作成可能に。Source選択でファイル選択ダイアログ追加。さらに若干の高速化。シェル経由起動＋キャンセルした場合、削除モード以外は自動終了しないように。その他リファイン。
v1.21 | 一部環境でシェル拡張メニューが出ない現象（v1.20でエンバグ）を修正
v1.20 | コピー完了時間予測機能追加。シェル拡張で、複数ファイル選択＋開くが機能しないことがあったのを修正。その他リファイン
v1.12 | シェル拡張のサブメニュー化オプション追加。シェル経由で大量のファイルを選択した場合に固まることがあったのを修正(v1.10-1.11 のみ)。ネットワークプレースでのシェル拡張の挙動を変更。その他リファイン
v1.11 | 一部環境で、実行が開始できない問題を修正
v1.10 | メインウィンドウのUNICODE化（UNICODEファイル名のドラッグ＆ドロップ等に対応）。セミコロンを含むパス名のファイルをドラッグ＆ドロップした場合、パス名を""で囲むように変更。シェル起動実行時の確認ダイアログを出さないモード追加。シェル拡張有効時に、スタートメニュー配下のディレクトリが開けなくなることがあったのを修正。その他リファイン。
v1.00 | 移動モードのサポート。シェル拡張機能追加。最前面オプション追加。エラーログ詳細化。/force_close オプション追加。メインメニュー＆設定ダイアログ追加。英語OS対応。その他リファイン。
v0.99 | 同一HDD内の別ドライブレターを別HDDモードと見なすことがあった（v0.90以降でエンバグ）のを修正。DestDir へのドラッグ＆ドロップを可能に。表示関係の修正、その他リファイン。
v0.98 | 削除中のキャンセルが効かないことがあったのを修正
v0.97 | エラーログ表示追加。ログファイルオプション追加。ドラッグ＆ドロップ時の挙動を変更
v0.96 | 高速削除モード追加。コマンドラインモードでのタスクトレイ格納条件を変更
v0.95 | ヘルプが開かないことがあったのを修正
v0.94 | 設定保存先をレジストリから ini ファイルに変更。DestDir にルートを指定すると落ちることがあったのを修正
v0.93 | デバッグ用ルーチンが残っていたのを削除
v0.92 | オプション設定を保存するようにした。コピー先ディレクトリが空の場合に落ちることがあったのを修正
v0.91 | 内部リファイン。
v0.90 | コピー元の複数指定およびドラッグ＆ドロップ指定を可能に。 コマンドライン時、タスクトレイモードをデフォルトに。 まれに余分に更新が発生する場合があったのを修正。
v0.88 | コマンドラインモード、タスクトレイ格納、 トレイ内アイコンアクション(?)、手抜きヘルプの追加。
v0.87 | 履歴の保存＆各種設定保存。
v0.86 | 同期モードの追加。
v0.85 | ファイル名比較で大文字小文字の区別をしないよう修正。
v0.84 | FAT/Sambaでの同一日付判定の修正。その他修正。
v0.83 | Update（上書きは、日付が新しいファイルのみ）モード追加。
v0.82 | src にワイルドカード指定が使えなくなっていたのを修正。
v0.81 | src/dstディレクトリエントリ取得を並列動作（別HDDモード）。
v0.80 | 差分コピーモード追加。
v0.70 | 同一HDD、別HDD モードの自動判定。
v0.66 | 一部バグフィクス。
v0.65 | ドライブタイプで動作を変化。エラー処理追加。
v0.64 | 稀にデッドロックを起こす可能性を発見したので修正。
v0.63 | Cancel ボタンの動作を「R/W Thread を Suspend した上 で確認」に変更。ファイル名表示はワードラップなしに。
v0.62 | NT系で物理メモリロックをデフォルトにするのをやめる。
v0.61 | ステータス領域を EDIT_BOX に変更（コピー可能に）。
v0.60 | 98系で動作するように修正。エラー無視チェック追加。
v0.50 | α版ファーストリリース。 (2004/09/27)


FastCopy Help

FastCopy ver2.08

2011/02/28 H.Shirouzu
Warning : This document was made with the Japanese-English translation software.
Original document is written in Japanese.
I want to correct this document. (If you made corrections, please send to me)

Index

1. About
2. License
3. Environment
4. Install
5. Usage
6. CommandLine
7. Warning
8. Latest Version/Contact
9. Misc
10. ToDo
11. History

1. About

FastCopy is the Fastest Copy/Delete Software on Windows.

It supports UNICODE and over MAX_PATH (260 byte) file pathnames.

It automatically selects different methods according to whether Source and DestDir are in the same or different HDD.
Diff HDD | Reading and writing are processed respectively in parallel by separate threads.
Same HDD | Reading is processed until the big buffer fills. When the big buffer filled, writing is started and processed in bulk.

Because Reading/Writing are processed with no OS cache at all, other applications don't easily become slow.

It can achieve Reading/Writing performance that is close to device limit.

Include/Exclude Filter (UNIX Wildcard style) can be specified.

It runs fast and does not hog resources, because MFC is not used. (Designed using Win32 API and C Runtime only)

You can modify this software, because all source code has been opened to the public in the BSD license.

2. License

Copyright 2004-2011 SHIROUZU Hiroaki All rights reserved.

Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:
1. Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

2. Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
THIS SOFTWARE IS PROVIDED BY SHIROUZU Hiroaki ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL SHIROUZU Hiroaki OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

3. Environment

Windows 98/Me/NT/2000/XP/2003/Vista/2008/Win7

4. Install

Install

Please run setup.exe, and install it in a new directory/folder.
If you want to install in USB memory, please copy the two files "fastcopy.exe" and "fastcopy.chm" to USB memory. (In this case, shell extension can't be used.)

Uninstall

If you want to uninstall, please run setup.exe located in the installed directory.
(Uninstall removes shortcut and unregister shell extension)

5. Usage

If main window is minimized, it is stored in task tray.
(In addition, the icon rotates while the copy is operating. )

Source / DestDir

FastCopy retains the history of 10 entries in Source/DestDir. (This can be increased or decreased in the Option | Main settings dialog.)
If you want to specify two or more files/dirs in the Source field, please use semicolon as a separator.
If you want to add files/dirs to the Source field by using drag and drop, simply drop with pushing CTRL button.

You can also drag & drop to DestDir field.

Regarding different behavior whether the end of DestDir character is '\' or not.

Source is one directory and the end of DestDir character is NOT '\'
Copy source directory's contents to DestDir.
(DestDir\Contents_of_SourceDir)

Other cases
Copy source directory that including it self to DestDir.
(DestDir\SourceDir\Contents_of_SourceDir)

Operation mode

Mode | Detail
Diff (No Overwrite) | Copy if the same filename doesn't exist in destination.
Diff (Size/date) | Copy if size or date is different, or if it doesn't exist (in default)
Diff (Newer) | Copy if source file timestamp is newer or doesn't exist.
Copy (Overwrite all) | Always copy/overwrite all.
Sync (Size/date) | Copy if size or date is different, or doesn't exist. In addition, delete all destination files/directories that don't exist in source.
Move (Overwrite all) | Always copy/overwrite all and delete all copied source files. (It is able to change "Move (Overwrite all)" -> "Move (Size/date)" in settings dialog.)
Delete | Delete all files/dirs by force.

Buttons & Options

Execute | The copy operation is executed. While copy is executing, this button changes "Cancel..." button. (The confirmation dialog is displayed, if this button is pushed with pushing CTRL button)
Listing | The files and directories list that will be copied and deleted are displayed. '+' means copying, and '-' means deleting.(Compare file pairs that will be skipped(except skipping by filter), if this button is pushed with pushing CTRL button(button label "listing" -> "listing+v"))
Buffer size | Specify the size(MB) of the main buffer for Read/Write oprations.
Speed Control | Specify "Full Speed", "Auto Slow"(*1), "90%"~"10%", "Suspend". If you feel it is hogging resources, it is recommended to set to "Auto Slow" (If it detects mouse moving/active window changing (and fastcopy window isn't foreground), it is slowed down). If "Full Speed" isn't selected, low process priority class is set. (This setting is not saved by job manage)
NonStop | Don't interrupt even if errors occur by Read/Write/Delete, and keep processing as much as possible. (However, errors are displayed in the main window, and recorded in the error log.)
Verify | Verify written files data by MD5(or SHA-1. If you want to use SHA-1, write [main] Using_MD5=0 in fastcopy.ini) ... Action detail: Read(Src) -> MD5(Src) -> Write(Dst) -> Read(Dst) -> MD5(Dst) -> Compare MD5(Src/Dst) (Of course, all actions are processed in parallel as much as possible)
Estimate | Display the estimated complete time. This means will cause FastCopy to investigates source tree before starting.
Top | FastCopy window is always top-level.
Start at once | Start at once without waiting for the finish of other FastCopy instance(s) executing. (This button doesn't show when other FastCopy isn't copying.)
"?" | Show help
(*1) It is slowed if fastcopy window isn't foreground and it is detected mouse moving, by waiting beetween I/O, changing process priority, changing I/O priority(Vista), and changing maximum I/O size.

ACL | Copy Access Control List (ACL). (Only applicable to NTFS)
Alt Stream | Copy Alternate Stream. (Only applicable to NTFS)
Wipe & Delete (prevent deleted files reviving) | Rename filename and Overwrite random data before deleting. Alternate stream isn't overwritten. If NSA method is checked in setting dialog, Overwriting Random data process runs two times, and overwriting NULL data process runs once.

Filter | Enable Include/Exclude/Date/Size filter. Note: It is always disabled in move mode.
Include | Copy only the files/directories that match up specified strings(UNIX Wildcard style). If you want to specify two or more strings, please use semicolon as separator. If you want to specify directories, please add '\' to the end of directory name. (For example: *.txt; My Folder [0-9]\)
Exclude | Don't copy the files/directories that match up specified strings.
The following filters are enabled when check "Option" -> "Show Extended filter".
FromDate | Don't copy the files that timestamp are older than specified date(format). This can be specified by not only absolute format ("20090322") but also by relative format (10days before ... "-10D").
ToDate | Don't copy files with timestamps newer than this specified date.
MinSize | Don't copy the files with sizes that are smaller than specified size. High number can be abbreviated using K/M/G/T character (Kilo/Mega/Giga/Tera).
MaxSize | Don't copy the files with sizes bigger than specified size.

 Include/Exclude filter(wildcard) format.
* | Zero or more arbitrary characters
? | One arbitrary character
[abc] | One character in "abc"
[!abc] | One character except "abc". '^' can also be used instead of '!'.
[a-z] | One character in "abc...xyz"
\ | Escape character (However, if '\' is the end of string character, it means a directory)
(Attention: In the future, filter string specification may be changed.)

FromDate/ToDate filter format.
Absolute | Specify "YYYYMMDD"(year/month/day). ex) "20090101"
Relative | Specify "+|- number W|D|h|m|s". W|D|h|m|s means Weeks/Days/hours/minutes/seconds. ex) "-12h" (This is case sensitive.)

Junction and SymLink

Junction(include MountPoint) and Symlink is understood in ver1.70 or later.
Mode | Details
Diff/Copy | Copy Junction/Symlink itself. If you want to change the copy Junction/Symlnk's target, it can be changed in the Options | Main settings dialog.
Move | Always move Junction/Symlink itself.
Delete | Always delete Junction/Symlink itself.

HardLink

HardLink can be reproduced as much as possible, if specify /linkdest option in ver1.95 or later.
(In running, "TotalFiles:" format changes "number_of_files (number_of_dirs)" to "number_of_files / number_of_created_hardlinks (number_of_dirs)").

Two very Important notes:
1. It needs 2-4MB per 10 thousand hardlink entity files. (It depends on path length)
2. It can decrease speed, because it opens not only copying files but also skip files.

If /linkdest option is enabled, /recreate option is enabled tacitly.
If you want always to enable /linkdest optoin, write [main] linkdest=1 in fastcopy.ini file.

Job Manage -> Add/Del Job

Register/Restore parameters in main window as named job.
Add/Modify | Add/Modify prameters in main window(Source/DestDir, Operation mode, Buffer size, Nonstop/Verify/Estimate/ACL/AltStream/Wipe&Delete/Filter checkboxes, Filter strings, HDD mode) as named job.
Delete | Delete registered job.

Option -> Main Settings

General settings. (change Default values, I/O parameters, and Copy Options, etc)

Option -> Shell Extensions

Register copy/delete menu items with Explorer's right click menu and right drag&drop menu.

Option -> Auto/Same/Diff HDD mode

Specify Auto/Same/Diff HDD mode(default: Auto).
CTL + K shortcut toggles between disk modes (auto -> same -> diff ->...)

Option -> Swap Source <-> DestDir

Swap Source for DestDir (for mutual update or etc).
Source/DestDir will be modified based on different behavior whether the end of DestDir character is '\' or not. (For example, If Source is "C:\AAA\BBB" and DestDir is "D:\CCC\", then Source becomes "D:\CCC\BBB" and DestDir becomes "C:\AAA\")
If Source has two or more files/directories, this menu item is disabled.
CTL+ALT+S is shortcut of this function.

Option -> Post-Process

Select Post-Process.
Allows user to change default settings (sound, command, and standby/hibernate/shutdown) after copy process/execution is complete. Also, user can add new Post-Process settings.

6. Command Line

A basic format is as follows.

fastcopy.exe [/options] file1 file2 ... [/to=dest_dir]

Please use space character(' ') as separator(not semicolon).
If filename contains space character, please enclose with dobule quotation marks.
Ex) fastopy.exe C:\Windows "C:\Program Files" /to="D:\Backup Folder\"

Supported options are as follows. (Please don't put space characters before and behind "=")

/cmd=(noexist_only|diff|update|sync|force_copy|move|delete) ... Specify operation mode.
(By default, diff mode is used. If delete mode is specified, then "/to=" option isn't used.)
cmdline | in GUI
noexist_only | Diff (No Overwrite)
diff | Diff (Size/date)
update | Diff (update)
force_copy | Copy (Overwrite)
sync | Sync (Size/date)
move | Move (Overwrite)
delete | Delete
/auto_close ... Close automatically after execution is finished with no errors.

/force_close ... Close automatically and forcedly after execution is finished.

/open_window ... Don't stored in the task tray.

/estimate ... Estimate complete time.

/no_exec ... Don't start to execute.

/no_confirm_del ... Don't confirm before deleting.

/no_confirm_stop ... Don't Show error dialog, Even if critical errors occurred.

/error_stop ... Show error dialog (and operation is interrupted), if an error occurred. (to disable, /error_stop=FALSE)

/bufsize=N(MB) ... Specify the size(MB) of the main buffer for Read/Write opration.

/log ... Write the operation/errors information to the logfile(fastcopy.log). (to disable, /log=FALSE)

/logfile=filename ... Specify the filename of logfile.

/filelog ... Write to the filelog(detail of copy/delete files). It is stored TIMESTAMP.log in FastCopy/Log directory. If using verify mode, write digest data(default:md5) as additional data. (To specify filelogname, /filelog=filename)

/utf8 ... Write to the logfile using UTF-8 encoding (supports Unicode).

/skip_empty_dir ... Skip to create empty directories when /include or /exclude option is used. (to disable, /log=FALSE)

/job=job_name ... Specify the job that is already registered.

/force_start ... Start at once without waiting for the finish of other FastCopy executing.

/disk_mode=(auto|same|diff) ... Specify Auto/Same/Diff HDD mode. (default: Auto)

/speed=(full|autoslow|9-1(90%-10%)|suspend) ... Specify speed control level.

/srcfile="files.txt" ... Specify source files by textfile. User is able to describe 1 filename per line. (Attention: If a lot of files are specified, it will take many times to display/refresh Source combobox.)

/srcfile_w="files.txt" ... same as "/srcfile=", except describing by UNICODE.

/include="..." ... Specify include filter. (details)

/exclude="..." ... Specify exclude filter. (details)

/from_date="..." ... Specify oldest timestamp filter. (details)

/to_date="..." ... Specify newest timestamp filter. (details)

/min_size="..." ... Specify minimum size filter. (details)

/max_size="..." ... Specify maximum size filter. (details)

/wipe_del ... Rename filename and wipe(overwrite Random data) before deleting.

/acl ... Copy ACL (only NTFS) (to disable, /acl=FALSE)

/stream ... Copy Alternate Stream (only NTFS) (to disable, /stream=FALSE)

/reparse ... Copy junction/mountpoint/symlink itself(to disable, /reparse=FALSE) (details)

/verify ... Verify written files data by MD5(or SHA-1) (to disable, /verify=FALSE) (details)

/linkdest ... Reproduce hardlink as much as possible. (details)

/recreate ... Change updating behavior "overwrite the target" to "delete and recreate the target". (If /linkdest option is enabled, this option is enabled by default.) If you want always to enable, write [main] recreate=1 in fastcopy.ini.

/postproc=actoin_name ... Specify post-process action name (to disable, /postproc=FALSE)

Ex) Copy C:\Test Folder to D:\Backup Folder by "diff(Size/Date)" mode is...
fastcopy.exe /cmd=diff "C:\Test Folder" /to="D:\Backup Folder\"

7. Warning

In some modes, destination files that exist with the same filename in source directories, are overwritten forcedly without confirming.
In sync mode, destination files that don't exist with the same filename in source directories, are deleted forcedly without confirming.
In delete mode, target files and directories are deleted forcedly without confirming.

If FastCopy has bugs, there is a possibility of serious problem.
Please use at your own risk. (See 2. License)

8. Latest Version/Contact

There is latest version & bulletin board in following URL.
http://ipmsg.org/tools/fastcopy.html
http://ipmsg.org/private/
email:

9. Misc

The setting file(FastCopy.ini) is ...
Vista or later and installed under \Program Files, it stored in \Users\(USER)\AppData\roaming\FastCopy\ (Menu File(F) -> UserDir(U))
Other case, it stored in the same directory of FastCopy.exe
The core routine of high performance copy is independent from GUI, you can use it(on BSD license) in your applications.

If FastCopy terminated abnormally, fastcopy_exception.log is generated.
(Please send this file to author, I will use for quality improvement)

10. ToDo

  • Direct network communication mode between two fastcopy processes. (Don't use SMB protocol)

    • 11. History

    Version | Detail
v2.08 | Append selected folder to source field, if it is pushed OK button in Source Folder Select Dialog with pushing CTRL key. Fix save path history problem(v2.07 only)
v2.07 | Prevent autocomplete of combobox at resizing main window. misc refine.
v2.06 | Fix exception at verify mode(v2.05 only).
v2.05 | Fix not to save settins in Win98. Enable to select writing ACL/AltStream errors to the log.
v2.04 | Enable drag & drop in admin mode on UAC. settings dialog and misc refine.
v2.03 | Fix "Elevate" menu item didn't work in English UI.
v2.02 | Release x64 native version. Store fastcopy.ini and logfiles in \Users\(USER)\AppData\roaming\FastCopy, if installed in \Progmram Files in Vista or Win7(UAC on/off is unrelated). Misc refine/fix.
v2.01 | Fix not to finish "move" in same HDD rarely. Restore not to require absolute path.
v2.00 | Add simple compare function("listing" with CTRL button). Store fastcopy.ini and logfiles in \Users\(USER)\AppData\roaming\FastCopy, if UAC is enabled and installed in \Progmram Files. Enable manual settings of Physical Drive group. Enable 32bit shell extension in 64bitOS. Fix exception when deleting Job.
v1.99r4 | Adjust destination filename to source filename when both upper/lower case are different (except "overwrite all" mode). Fix showing no detail error.
v1.99r3 | Fix automatically decision of HDD mode problem.(v1.99r2 only) Improve to estimate complete time.
v1.99r2 | Add detail filelog option(/filelog). Enable filter in move mode. Speed up starting (Replace API's inifile access by original routine.) Affect filter for the files those are specified direct in Source EditBox. Modify /srcfile option when using MBCS in srcfile contents. Additionally, refinement
v1.98 | Add Extended (filesize/timestamp) filter. ("Option" -> "show extended filter")
v1.97 | Correct that sometimes it failed to play sound in post-process action. Additionally, refinement
v1.96 | If /linkdest option is enabled, change updating behavior "overwrite the target" to "delete and recreate the target". Add option(/recreate) that change updating behavior "overwrite the target" to "delete and recreate the target", regardless of specifying /linkdest option.
v1.95 | Add reproduce hardlink option(/linkdest). Change showing Post-Process notice dialog as foreground. Correct wrong freeing memory at termination.(v1.93-v1.94) Correct that sometimes ACL/Stream copying failed.
v1.94 | Correct that helpfile can't be opened.(v1.93 only)
v1.93 | Add Post-Process(shutdown or etc) menu. Add "open log" menu. Add /srcfile option.(specify source files by textfile). Correct that JobMng saved "Delete" mode as "move" mode(v1.80-v1.92 only). Correct that installation option(creating shortcut) didn't work at Non-English OS.(v1.92 only)
v1.92 | Correct English document. Add "run in task tray" option in shell extension. Correct that sometimes incomplete file remained when error occurred.
v1.91 | Correct that sometimes "wipe and delete" failed. Correct that "move with verification" wasn't finished rarely. Correct that network drive in directory select dialog didn't show.
v1.90 | Speed up verification. (I/O and verification are processed by parallel.) Switching SHA-1 to MD5 for verification as default.(If you want to use SHA-1, write [main] Using_MD5=0 in fastcopy.ini). Add to fix window position/size in menu. Add Source/DestDir swapping in menu.
v1.84 | Correct wildcard filter problem. (when many wildcard strings were registered, unregistered string was occured rarely. To be exact, when sum of registered characters are just 62*n, boundary string wasn't registered)
v1.83 | Using OS cache at reading option is ON, although it is disabled OS cache for verify reading.
v1.82 | Add using OS cache at reading option.(OS Cached file reading will be faster. But not OS cached file reading require new OS cache area, and it will has bad effect for virtual memory area(swap or etc). this option is not recommended for normal use.)
v1.81 | Correct move with verify mode.(if verify error occurs, sometimes process doesn't finish.)
v1.80 | Add verify option by SHA-1. Add "paste" menuitem in shell extension. Add move(Size/date) mode. Add move as one by one option. Auto reduce MaxIO size(if ERROR_NO_SYSTEM_RESOURCES is occured). Add suppressing confirm dialog at stopping error(/no_confirm_stop).
v1.71 | Correct registering shell extension problem (Win2000/Me/98 only)
v1.70 | Interpret Junction/Symlink (by default, it is copied Junction/Symlink itself (not target childs). In remove mode, it is always removed only Junction/Symlink itself). Elevate Admin(for Vista UAC). Add shell extension for 64bitOS. Add logging as UTF-8 option. Add logging filename option(/logfile=). Expand error log area.
v1.63 | Change size limit of filter strings(62->2048chars)
v1.62 | Correct CreateFile error that is caused by generating illegal dest path.(1.60/61 only)
v1.61 | If string length is over 8192 chars in src field, it is truncated 8192 chars at executing. (v1.60 only)
v1.60 | NTFS Access Control List(ACL), Alternate Stream support. Add Wipe & Delete option (normal and NSA method) for delete mode. Change Process Priority Class at using Auto Slow function.Changing "Auto Slow" checkbox to slider control.
v1.55 | Modify PopupDialog Position at tasktray mode
v1.54 | Modify for NT4.0
v1.53 | When executing in tasktray by command line, it don't get focus. In the multi monitor, the window shows in the monitor that has mouse pointer. Modify to enable /error_stop option.
v1.52 | Addition of Auto Slow function. It is corrected that too strictly time stamp judgment in some UDF filesystems. It is corrected that control specification (=FALSE) of the command line option did not work effectively.
v1.51 | When two or more different directories are specified for src and using estimating option, it terminated abnormally sometimes occasionally.
v1.50 | Enable to the filter specification in the synchronous mode.
v1.40 | Addition of job management function. Addition of preview listing function. Addition of multiple fastcopy process control option. When the filter is specified, the option not to make an empty directory is added. Addition of automatic operation/same/another HDD mode specification. The resize of the main window is possible. Informative label of API error. Additionally, refinement
v1.32 | It is corrected that the Include/Exclude filter was invalid at the command line. Additionally, refinement
v1.31 | It is corrected to have fallen immediately after execution when a lot of specification is done with the Include/Exclude filter occasionally.
v1.30 | Include/Exclude filter function addition. When drag & is dropped in the same directory, the reproduction is made possible. It adds it by the Source selection the file selection dialog. In addition, some speed-up. Do not end excluding the deletion mode automatically when start by way of the shell + canceling. Other refinement.
v1.21 | A part of phenomenon of not coming out the shell enhancing menu in the environment (It is v1.20's enbug) is corrected.
v1.20 | Forecast function addition of copy completion time. It is corrected not to have functioned occasionally though it two or more file selection + opens by enhancing the shell. Other refinement
v1.12 | Option of making to submenu addition of shell enhancing. It is corrected to have hardened when a large amount of file is selected by way of the shell occasionally (Only v1.10-1.11). The behavior of the shell enhancing with Nettowarcpras is changed. Other refinement
v1.11 | In the environment, a part of problem that execution cannot begin is corrected.
v1.10 | Making of the main window (Correspond to the drag & drop etc. of the UNICODE file name) UNICODE. To enclose the path name with ""when drag & is dropped, the file of the path name including the semicolon is changed. Mode addition that doesn't put out confirmation dialog when shell start is executed. It is corrected that the shell enhancing and the directory under the control of the start menu did not open it when it is effective occasionally. Other refinement.
v1.00 | 1.00 release (2005/03/10)
v0.50 | 1st alpha release (2004/09/27)